#pragma once
#include <map>
#include <string>
#include <vector>
#include "../core/value.h"

enum PropertyFlags {
    OB_PROP_READ_ONLY = 1, // The property cannot be set
    // OB_PROP_CALLBACK = 2, // The proeprty is get/set through a function instead of directly to a field
};

enum MethodFlags {
    // OB_METHOD_OVERLOADED = 1, // The method has multiple definitions with different parameters suffixed by __ followed by a number
};

enum InstanceFlags {
    OB_INST_NOT_CREATABLE = 1,
};

struct PropertyInfo {
    PropertyFlags flags;
    void* fieldPointer;
    ValueType valueType;
};

struct MethodInfo {
    MethodFlags flags;
    void* functionPointer;
    ValueType returnType;
    std::vector<ValueType> parameterTypes;    
};

struct InstanceType {
    InstanceType* superClass = nullptr;
    std::string className;
    InstanceFlags flags;
    std::map<std::string, PropertyInfo> properties;
    std::map<std::string, MethodInfo> methods;
};
